import { Dash4Plugin, IDash4Plugin } from '@dash4/server';
import { IAllowedCommand, IClientConfig, IRecieveFromClientCb, IRecieveFromClientEventNames, ISendToClientData, ISendToClientEventNames } from '../shared-types';
export * from './jest-commands';
export interface IOptions {
    cmd: string;
    cwd?: string;
    allowedCommands?: IAllowedCommand[];
    dark?: boolean;
    autostart?: boolean;
    width?: number[];
}
export declare class PluginTerminal extends Dash4Plugin<IRecieveFromClientEventNames, IRecieveFromClientCb, ISendToClientEventNames, ISendToClientData> implements IDash4Plugin<IClientConfig> {
    private _cmd;
    private _cwd;
    private _terminalLog;
    private _autostart;
    private _term?;
    private _stopProcessingTriggered;
    private _allowedCommands?;
    constructor({ dark, width, cmd, cwd, autostart, allowedCommands }: IOptions);
    create(): void;
    readonly clientConfig: {
        cmd: string;
        cwd: string;
        allowedCommands: {};
    };
    readonly clientFiles: string[];
    connected: () => void;
    private handleConnected;
    private handleTermStopProcessing;
    private getCommandById;
    private appendCommand;
    private appendCommandInput;
    private recieveData;
    private kill;
    private write;
    private stop;
    private clean;
    private start;
}
